# Mining Caves

Created by [OrianaVentureMod@gmail.com](https://github.com/OrianaVenture/VentureValheim).

## Introduction

Adds two new caves to the world containing ore for mining. Adds the ability to disable terrain changes caused by tools.

## Features

* Adds a cave for mining Copper and Tin in the Black Forest (prefab name VV_CopperTinCave)
<br>
<img alt="Caves" height="300" src="https://raw.githubusercontent.com/OrianaVenture/VentureValheim/master/MiningCaves/pictures/MiningCaves-CopperTin-Outer.png?raw=true" />
<img alt="Caves" height="300" src="https://raw.githubusercontent.com/OrianaVenture/VentureValheim/master/MiningCaves/pictures/MiningCaves-CopperTin-Inter.png?raw=true" />


* Adds a cave for mining Silver in the Mountains (prefab name VV_SilverCave)
<br>
<img alt="Caves" height="300" src="https://raw.githubusercontent.com/OrianaVenture/VentureValheim/master/MiningCaves/pictures/MiningCaves-Silver-Outer.png?raw=true" />
<img alt="Caves" height="300" src="https://raw.githubusercontent.com/OrianaVenture/VentureValheim/master/MiningCaves/pictures/MiningCaves-Silver-Inter.png?raw=true" />

* Adds the ability to prevent player terrain changes from tools

### Adding Caves

* If creating a new world with this mod installed the caves will be added automatically on world generation.
* If you are adding this to an existing world you can run the vanilla "genloc" command to add caves to unexplored areas of the map. Be aware this can change the positions of boss locations and can make your map pins inaccurate.
* If your map is heavily explored you will need to use another mod to automatically add the locations to explored areas.

Use the find command such as "find VV_SilverCave 50" in game after creating a world to have all these locations added to your map as pins. This will help you ensure the world had a good spawn. Example of the warning message displayed in your log file on a bad spawn after initial world generation:

```
Failed to place all VV_SilverCave, placed 5 out of 50
```

Don't know how to use commands? Dedicated servers do not allow for use of commands, but there are mods that can enable them (like Server devcommands by JereKuusela). The commands mentioned above are considered a "cheat". To use cheats you must enable them with the "devcommands" command, you may have to be an admin for them to work depending on what mod you use to access commands.

### Locking Terrain Changes

I think terrain changes in general look ugly. This was the main idea that inspired the whole mod. To prevent players from being able to modify the terrain set the LockTerrain configuration to True. The AdminBypass configuration will allow all admins to still perform terrain changes when turned on. If there are items you would like the mod to ignore add the prefab names to the LockTerrainIgnoreItems configuration as a comma-separated string (for example: Cultivator, Hoe, PickaxeAntler). This should work with custom items added by other mods. All original piece table entries on tools (like the Hoe) that have a "raise" component are removed with this feature to prevent players from spending resources accidentally.

This feature can potentially prevent players from mining the default silver nodes in the mountains. Ensure enough silver caves are generated by checking your log file on first world generation.

### Location Reset

This mod can be very useful on large servers where surface ores are quickly exhausted. Use my other mod [Location Reset](https://valheim.thunderstore.io/package/VentureValheim/Venture_Location_Reset/) with this mod to regenerate caves and refresh the ore supply. There are custom configurations to change each cave's reset rate in the Location Reset configuration file.

### Pathside Assistance

If you do not wish to disable terrain changes entirely but want the option to create nice paths without altering the terrain check out the [Pathside Assistance](https://valheim.thunderstore.io/package/VentureValheim/Pathside_Assistance/) mod.

### Possible Future Improvements

* World generation option to not place silver nodes and/or
* Removal of the wishbone ping from unobtainable silver nodes

## Installation

This mod needs to be on both the client and server; the mod will enforce installation. Players without the mod will NOT be able to connect to the server. Config Syncing is included with Jotunn. The server with enforce the same mod configuration for all players. Live changes to the configurations will not always take effect until the player relogs into the world/server.

If the mod is removed from the server after locations have been generated the caves will not reappear, but some things will remain in the world. Adding the mod back after removing it will restore all caves previously generated in the same place.

## Changelog

### 0.1.3

* Fixed issue where patches may have applied before the initial server configuration syncing event. This made some server configurations not apply correctly.
* Fixed LockTerrainIgnoreItems config not applying to the correct items when used.
* Fixed Obsidian falling out of caves.
* Internally removed clearing Jotunn cache, this is now a feature in version 2.17.0, update Jotunn to upgrade this mod.

### 0.1.2

* Fixed copper node in cave painting the surface terrain.
* Tweaked silver cave spawn rates, about 40 should be placed consistently now on world generation.
* Fixed Tin falling out of caves.

### 0.1.1

* Fixed an issue where items like ores would sometimes not display (needed to clear mesh cache for mocking).
* Added missing file watcher for updating configurations without a server restart.

### 0.1.0

* First release

## Contributing

All issues can be reported on the project Github. To report issues please be as specific as possible and provide the following:

1. Version of this mod you are using.
2. List of the other mods being used.

All feedback, ideas, and requests are welcome! You can message me at my discord [Venture Gaming](https://discord.gg/tAd5hapt88).